#include "../include/instruction_handler.h"
#include "../include/logger.h"
#include "../include/display.h"

InstructionHandler::InstructionHandler() {
    this->handlers[0x0000] = handle0000;
}

void InstructionHandler::handleInstruction(unsigned short instructionNumber, const Chip8& chip8, Instruction instruction) {
    if (!this->handlers.contains(instructionNumber)) {
        Logger::error("Unregistered instruction", instructionNumber);
        return;
    }

    this->handlers[instructionNumber](chip8, instruction);
}

void InstructionHandler::handle0000(const Chip8& chip8, Instruction instruction) {
    switch (instruction.kk()) {
        case 0x00E0:
            chip8.getDisplay()->clear();
            break;
        case 0x00EE:

            break;
    }
}

